/*
** server.c 
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include <signal.h>
#include "mysha2.c"
#include "otp.c"
#include "sms.c"
#define BACKLOG 10    // how many pending connections queue will hold
#define MAXDATASIZE 100 // max number of bytes we can get at once


//////////////////////////////////////////////////////////////////////////////////////////////////////////////

char PORT[10];
char MOBILENO[15];
char USERNAME[25];
char OTP[100];

/////////////////////////////Readconfiguration file///
void readconfig()
{
//////////////////////Reading strings from file////////////////
    char s[1024],*token,ftoken[20];
 	int count=0,i=0,c=0;    
	FILE *stream;
     if((stream = fopen ("./server.cnf", "r+")) != NULL) {
       while((fgets(s, 1023, stream)) != NULL) {
	// put the code for reading file from client and server cnf file.         
	token=strtok(s,":");
	token=strtok(NULL,"\n");
	count=0;
	i=0;	
	while(i<strlen(token)){
		
		if(isspace(token[i])){
		}
		
		else{
		ftoken[count]=token[i];
		count++;
		     }
		i++;		
		}
	ftoken[count]='\0';
	if(c==0)
	{
	strcpy(PORT,ftoken);
	c++;
	//printf("%s\n",PORT);	
       
	}
	
       } 
    } 
     else {
        printf("can not open file");
    }
fclose(stream);

}

///////////////////////////////////getting user info//////////////////
void getuserinfo(char s[])
{
char *token,ftoken[25];
token=strtok(s,",");
strcpy(USERNAME,token);
token=strtok(NULL,"\n");
int i=0,count=0;	
	while(i<strlen(token)){
		
		if(isspace(token[i])){
		}
		
		else{
		ftoken[count]=token[i];
		count++;
		     }
		i++;		
		}
	ftoken[count]='\0';

strcpy(MOBILENO,ftoken);
printf("Mobile#=%s\n",MOBILENO);
}

///////////////////////////////////////////////////////////////////

void sigchld_handler(int s)
{
    while(waitpid(-1, NULL, WNOHANG) > 0);
}
// get sockaddr, IPv4 or IPv6:
void *get_in_addr(struct sockaddr *sa)
{
    if (sa->sa_family == AF_INET) {
        return &(((struct sockaddr_in*)sa)->sin_addr);
    }
    return &(((struct sockaddr_in6*)sa)->sin6_addr);
}
////////////////////////////////////////////////////////////////
void server_task(int new_fd)
{

////////////receiving data from client//
char buf[MAXDATASIZE];
int numbytes;
if ((numbytes = recv(new_fd, buf, MAXDATASIZE-1, 0)) == -1) {
        perror("recv");
      exit(1);
  }
  buf[numbytes] = '\0';
  getuserinfo(buf);
	printf("User Name Connected to Server: %s\n",buf);


//sha(USERNAME);
//strcpy(OTP,sOTP);

otp(USERNAME);
strcpy(OTP,dOTP);

/////////////////Send mobile and OTP to SMS Server///
//sendSMS(MOBILENO,OTP);
printf("OTP=%s\n",OTP);



////////////receiving data from client//
if ((numbytes = recv(new_fd, buf, MAXDATASIZE-1, 0)) == -1) {
        perror("recv");
      exit(1);
  }
  buf[numbytes] = '\0';


char retval[20];
if(strcmp(buf,OTP)==0)
{
strcpy(retval,"PAM_SUCCESS");
}
else
{
strcpy(retval,"PAM_USER_UNKNOWN");
}

//////////sending info to client///


if (send(new_fd, retval, strlen(retval), 0) == -1)
               perror("send");

}

//////////////////////////////////////
int main(void)
{
    readconfig();
    int sockfd, new_fd; // listen on sock_fd, new connection on new_fd
    struct addrinfo hints, *servinfo, *p;
    struct sockaddr_storage their_addr; // connector's address information
    socklen_t sin_size;
    struct sigaction sa;
    int yes=1;
    char s[INET6_ADDRSTRLEN];
    int rv;
    memset(&hints, 0, sizeof hints);
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags = AI_PASSIVE; // use my IP
	
	

    if ((rv = getaddrinfo(NULL, PORT, &hints, &servinfo)) != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
        return 1;
    }
    // loop through all the results and bind to the first we can
    for(p = servinfo; p != NULL; p = p->ai_next) {
        if ((sockfd = socket(p->ai_family, p->ai_socktype,
                 p->ai_protocol)) == -1) {
            perror("server: socket");
            continue;
        }
        if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &yes,
                 sizeof(int)) == -1) {
            perror("setsockopt");
            exit(1);
        }
        if (bind(sockfd, p->ai_addr, p->ai_addrlen) == -1) {
            close(sockfd);
            perror("server: bind");
            continue;
        }
        break;
    }
    if (p == NULL) {
        fprintf(stderr, "server: failed to bind\n");
        return 2;
    }
    freeaddrinfo(servinfo); // all done with this structure
    if (listen(sockfd, BACKLOG) == -1) {
        perror("listen");
        exit(1);
    }
  sa.sa_handler = sigchld_handler; // reap all dead processes
  sigemptyset(&sa.sa_mask);
  sa.sa_flags = SA_RESTART;
  if (sigaction(SIGCHLD, &sa, NULL) == -1) {
      perror("sigaction");
      exit(1);//sha();
  }
  printf("server: waiting for connections...\n");
  while(1) { // main accept() loop
      sin_size = sizeof their_addr;
      new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size);
      if (new_fd == -1) {
          perror("accept");
          continue;
      }
      inet_ntop(their_addr.ss_family,
          get_in_addr((struct sockaddr *)&their_addr),
          s, sizeof s);
      printf("server got connection from %s:%s\n", s, PORT);
      if (!fork()) { // this is the child process
          close(sockfd); // child doesn't need the listener
	
	//////////////////////////////////calling the functionality of server//////////         
		server_task(new_fd);
	/////////////////////////////////////////////////////////////////////////////// 
          close(new_fd);
          exit(0);
      }
      close(new_fd); // parent doesn't need this
  }
  return 0;
}



