#include <security/pam_appl.h>
#include <security/pam_misc.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <ctype.h>

//////////////////Defining the variables//////////////
//#define PORT "3490"
#define MAXDATASIZE 100 // max number of bytes we can get at once

char IP[20];      //ip of the MOBA server
char PORT[10];    // the port client will be connecting to
char MOBILENO[25];
char USERNAME[25];

///Default conversation structure/////////
static struct pam_conv conv = { 
misc_conv, 
NULL
};


//////////////////////get User Info//////////////
void getuserinfo(char s[])
{
char *token,ftoken[25];
token=strtok(s,",");
strcpy(USERNAME,token);
printf("USERNAME=%s\n",USERNAME);
token=strtok(NULL,"\n");
int i=0,count=0;	
	while(i<strlen(token)){
		
		if(isspace(token[i])){
		}
		
		else{
		ftoken[count]=token[i];
		count++;
		     }
		i++;		
		}
	ftoken[count]='\0';

strcpy(MOBILENO,ftoken);
printf("Mobile#=%s\n",MOBILENO);
}


// get sockaddr, IPv4 or IPv6:
void *get_in_addr(struct sockaddr *sa)
{
    if (sa->sa_family == AF_INET) {
        return &(((struct sockaddr_in*)sa)->sin_addr);
    }
    return &(((struct sockaddr_in6*)sa)->sin6_addr);
}

///////Reading configuration from client.cnf//////////
void readconf()
{
//Reading strings from file//////
    char s[1024],*token,ftoken[20];
 	int count=0,i=0,c=0;    
	FILE *stream;
     if((stream = fopen ("/home/usman/Project/client.cnf", "r+")) != NULL) {             //setting path for configuration file
       while((fgets(s, 1023, stream)) != NULL) {
	// put the code for reading file from client and server cnf file.         
	token=strtok(s,":");
	token=strtok(NULL,"\n");
	count=0;
	i=0;	
	while(i<strlen(token)){
		
		if(isspace(token[i])){
		}
		
		else{
		ftoken[count]=token[i];
		count++;
		     }
		i++;		
		}
	ftoken[count]='\0';
	if(c==0)
	{
	strcpy(IP,ftoken);
	printf("IP=%s\n",IP);
	c++;		
	}
	else if(c==1)
	{
	strcpy(PORT,ftoken);	
	c++;	
	printf("PORT=%s\n",PORT);	
	}
       } 
    } 
     else {
        printf("can not open file");
    }
fclose(stream);

}

//////////////////Communication With MOBA server/////////
void MOBA_comm(char *puserinfo)
{
/////////////////////client code//////////
	int sockfd, numbytes;
    	char buf[MAXDATASIZE];
    	struct addrinfo hints, *servinfo, *p;
    	int rv;
    	char s[INET6_ADDRSTRLEN];
    	memset(&hints, 0, sizeof hints);
    	hints.ai_family = AF_UNSPEC;
    	hints.ai_socktype = SOCK_STREAM;
    	if ((rv = getaddrinfo(IP, PORT, &hints, &servinfo)) != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
        }
    // loop through all the results and connect to the first we can
    	for(p = servinfo; p != NULL; p = p->ai_next) {
        if ((sockfd = socket(p->ai_family, p->ai_socktype,
                 p->ai_protocol)) == -1) {
            perror("client: socket");
            continue;
        }
        if (connect(sockfd, p->ai_addr, p->ai_addrlen) == -1) {
            close(sockfd);
            perror("client: connect");
            continue;
        }
        break;
    	}
    	if (p == NULL) {
        fprintf(stderr, "client: failed to connect\n");
        
    }
    inet_ntop(p->ai_family, get_in_addr((struct sockaddr *)p->ai_addr),s, sizeof s);
    printf("client: connecting to %s\n", s);
    freeaddrinfo(servinfo); // all done with this structure


////////////////////sending data///////////

int len=strlen(puserinfo);
if (send(sockfd, puserinfo, len, 0) == -1)
               perror("send");

///////////getting the password and sending it//////////////
char *hold=getpass("MOBA Password:");
len=strlen(hold);
if (send(sockfd, hold, len, 0) == -1)
               perror("send");
/////////////receiving data///////////////
if ((numbytes = recv(sockfd, buf, MAXDATASIZE-1, 0)) == -1) {
        perror("recv");
      exit(1);
  }
  buf[numbytes] = '\0';
  printf("client: received '%s'\n",buf);

/////closing socket//////////////////////
  close(sockfd);


//////////////////end client code/////////


}



//////////main function/////////////

int main() 
{ 
char holddata[100];
pam_handle_t *pamh = NULL; 
int retval;

char *user= NULL;//getlogin(); 

////get the user name from user//
pam_get_user(pamh,PAM_USER_PROMPT,"");

/** Creating and initializing a PAM session **/ 
retval = pam_start("login", user, &conv, &pamh); 

if (retval == PAM_SUCCESS)     
{
retval = pam_authenticate(pamh, 0); 	/** Authenticate user **/ 
	if(retval==PAM_SUCCESS)
		{	
		printf("Authentication Successful\t retval=%d\n",retval);
		char *lgn;		
		struct passwd *pw;
		if ((pam_get_user(pamh,&lgn,NULL)) != PAM_SUCCESS || (pw = getpwnam(lgn)) ==NULL) {
    		fprintf(stderr, "Get of user information failed.\n"); exit(1);
		}
		else{
		//char *puserinfo=pw->pw_gecos;		//getting user info
		//printf("username=%s\n",puserinfo);
		readconf();
		strcpy(holddata,pw->pw_gecos);		
		getuserinfo(holddata);
		if(strlen(MOBILENO)>5)
		{
		MOBA_comm(pw->pw_gecos);
		}

		    }		
		}	
	////////////Remove this portion at the end	
	else
	{
	printf("Not Authenticated\n");
	
	}
}


////////////////ending the PAM session//////////
 if (pam_end(pamh,retval) != PAM_SUCCESS) {     /* close Linux-PAM */
	pamh = NULL;
	fprintf(stderr, "check_user: failed to release authenticator\n");
	exit(1);
    }

    
///// return the retval value////
return  retval;      /* indicate success */

}
